diff --git a/src/allmydata/test/test_web.py b/src/allmydata/test/test_web.py
index f68e98d..cc9be0d 100644
--- a/src/allmydata/test/test_web.py
+++ b/src/allmydata/test/test_web.py
@@ -19,7 +19,7 @@ from allmydata.nodemaker import NodeMaker
 from allmydata.unknown import UnknownNode
 from allmydata.web import status, common
 from allmydata.scripts.debug import CorruptShareOptions, corrupt_share
-from allmydata.util import fileutil, base32
+from allmydata.util import fileutil, base32, hashutil
 from allmydata.util.consumer import download_to_data
 from allmydata.util.netstring import split_netstring
 from allmydata.util.encodingutil import to_str
@@ -78,34 +78,40 @@ def build_one_ds():
     ds = DownloadStatus("storage_index", 1234)
     now = time.time()
 
-    ds.add_segment_request(0, now)
-    # segnum, when, start,len, decodetime
-    ds.add_segment_delivery(0, now+1, 0, 100, 0.5)
-    ds.add_segment_request(1, now+2)
-    ds.add_segment_error(1, now+3)
+    serverid_a = hashutil.tagged_hash("foo", "serverid_a")[:20]
+    serverid_b = hashutil.tagged_hash("foo", "serverid_b")[:20]
+    storage_index = hashutil.storage_index_hash("SI")
+    e0 = ds.add_segment_request(0, now)
+    e0.activate(now+0.5)
+    e0.deliver(now+1, 0, 100, 0.5) # when, start,len, decodetime
+    e1 = ds.add_segment_request(1, now+2)
+    e1.error(now+3)
     # two outstanding requests
-    ds.add_segment_request(2, now+4)
-    ds.add_segment_request(3, now+5)
+    e2 = ds.add_segment_request(2, now+4)
+    e3 = ds.add_segment_request(3, now+5)
+    del e2,e3 # hush pyflakes
 
-    # simulate a segment which gets delivered faster than a system clock tick (ticket #1166)
-    ds.add_segment_request(4, now)
-    ds.add_segment_delivery(4, now, 0, 140, 0.5)
+    # simulate a segment which gets delivered faster than a system clock tick
+    # (ticket #1166)
+    e = ds.add_segment_request(4, now)
+    e.activate(now)
+    e.deliver(now, 0, 140, 0.5)
 
-    e = ds.add_dyhb_sent("serverid_a", now)
+    e = ds.add_dyhb_request(serverid_a, now)
     e.finished([1,2], now+1)
-    e = ds.add_dyhb_sent("serverid_b", now+2) # left unfinished
+    e = ds.add_dyhb_request(serverid_b, now+2) # left unfinished
 
     e = ds.add_read_event(0, 120, now)
     e.update(60, 0.5, 0.1) # bytes, decrypttime, pausetime
     e.finished(now+1)
     e = ds.add_read_event(120, 30, now+2) # left unfinished
 
-    e = ds.add_request_sent("serverid_a", 1, 100, 20, now)
+    e = ds.add_block_request(serverid_a, 1, 100, 20, now)
     e.finished(20, now+1)
-    e = ds.add_request_sent("serverid_a", 1, 120, 30, now+1) # left unfinished
+    e = ds.add_block_request(serverid_a, 1, 120, 30, now+1) # left unfinished
 
     # make sure that add_read_event() can come first too
-    ds1 = DownloadStatus("storage_index", 1234)
+    ds1 = DownloadStatus(storage_index, 1234)
     e = ds1.add_read_event(0, 120, now)
     e.update(60, 0.5, 0.1) # bytes, decrypttime, pausetime
     e.finished(now+1)
@@ -554,10 +560,15 @@ class Web(WebMixin, WebErrorMixin, testutil.StallMixin, testutil.ReallyEqualMixi
         def _check_dl(res):
             self.failUnless("File Download Status" in res, res)
         d.addCallback(_check_dl)
-        d.addCallback(lambda res: self.GET("/status/down-%d?t=json" % dl_num))
+        d.addCallback(lambda res: self.GET("/status/down-%d/event_json" % dl_num))
         def _check_dl_json(res):
             data = simplejson.loads(res)
             self.failUnless(isinstance(data, dict))
+            # this data comes from build_one_ds() above
+            self.failUnlessEqual(set(data["serverids"].values()),
+                                 set(["phwr", "cmpu"]))
+            self.failUnlessEqual(len(data["segment"]), 5)
+            self.failUnlessEqual(len(data["read"]), 2)
         d.addCallback(_check_dl_json)
         d.addCallback(lambda res: self.GET("/status/up-%d" % ul_num))
         def _check_ul(res):
diff --git a/src/allmydata/web/download-status-timeline.xhtml b/src/allmydata/web/download-status-timeline.xhtml
new file mode 100644
index 0000000..abc7145
--- /dev/null
+++ b/src/allmydata/web/download-status-timeline.xhtml
@@ -0,0 +1,33 @@
+<html xmlns:n="http://nevow.com/ns/nevow/0.1">
+  <head>
+    <title>AllMyData - Tahoe - File Download Status Timeline</title>
+    <link href="/tahoe_css" rel="stylesheet" type="text/css"/>
+    <link href="/webform_css" rel="stylesheet" type="text/css"/>
+    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
+    <script type="text/javascript" src="/jquery.js"></script>
+    <script type="text/javascript" src="/protovis-r3.2.js"></script>
+    <script type="text/javascript" src="/download_status_timeline.js"></script>
+  </head>
+  <body>
+
+<h1>File Download Status</h1>
+
+<ul>
+  <li>Started: <span n:render="started"/></li>
+  <li>Storage Index: <span n:render="si"/></li>
+  <li>Helper?: <span n:render="helper"/></li>
+  <li>Total Size: <span n:render="total_size"/></li>
+  <li>Progress: <span n:render="progress"/></li>
+  <li>Status: <span n:render="status"/></li>
+</ul>
+
+
+<div style="">
+  <div id="overview" style="float:right;width:166px;height:100px; border: 1px solid #ddd">overview</div>
+  <div id="timeline" style="width:600px;border: 1px solid #aaa">Timeline</div>
+</div>
+
+<div>Return to the <a href="/">Welcome Page</a></div>
+
+  </body>
+</html>
diff --git a/src/allmydata/web/download-status.xhtml b/src/allmydata/web/download-status.xhtml
index 30abfca..b3560ed 100644
--- a/src/allmydata/web/download-status.xhtml
+++ b/src/allmydata/web/download-status.xhtml
@@ -16,6 +16,7 @@
   <li>Total Size: <span n:render="total_size"/></li>
   <li>Progress: <span n:render="progress"/></li>
   <li>Status: <span n:render="status"/></li>
+  <li><span n:render="timeline_link"/></li>
 </ul>
 
 <div n:render="events"></div>
diff --git a/src/allmydata/web/download_status_timeline.js b/src/allmydata/web/download_status_timeline.js
new file mode 100644
index 0000000..ca48eb1
--- /dev/null
+++ b/src/allmydata/web/download_status_timeline.js
@@ -0,0 +1,144 @@
+
+$(function() {
+
+      function onDataReceived(data) {
+          var bounds = { min: data.bounds.min,
+                         max: data.bounds.max
+                       };
+          //bounds.max = data.dyhb[data.dyhb.length-1].finish_time;
+          var duration = bounds.max - bounds.min;
+          var WIDTH = 600;
+          var vis = new pv.Panel().canvas("timeline").margin(30);
+
+          var dyhb_top = 0;
+          var read_top = dyhb_top + 30*data.dyhb[data.dyhb.length-1].row+60;
+          var segment_top = read_top + 30*data.read[data.read.length-1].row+60;
+          var block_top = segment_top + 30*data.segment[data.segment.length-1].row+60;
+          var block_row_to_y = {};
+          var row_y=0;
+          for (var group=0; group < data.block_rownums.length; group++) {
+              for (var row=0; row < data.block_rownums[group]; row++) {
+                  block_row_to_y[group+"-"+row] = row_y;
+                  row_y += 10;
+              }
+              row_y += 5;
+          }
+
+          var height = block_top + row_y;
+          var kx = bounds.min;
+          var ky = 1;
+          var x = pv.Scale.linear(bounds.min, bounds.max).range(0, WIDTH-40);
+          var relx = pv.Scale.linear(0, duration).range(0, WIDTH-40);
+          //var y = pv.Scale.linear(-ky,ky).range(0, height);
+          //x.nice(); relx.nice();
+
+          /* add the invisible panel now, at the bottom of the stack, so that
+          it won't steal mouseover events and prevent tooltips from
+          working. */
+          vis.add(pv.Panel)
+              .events("all")
+              .event("mousedown", pv.Behavior.pan())
+              .event("mousewheel", pv.Behavior.zoom())
+              .event("pan", transform)
+              .event("zoom", transform)
+          ;
+
+          vis.anchor("top").top(-20).add(pv.Label).text("DYHB Requests");
+
+          vis.add(pv.Bar)
+              .data(data.dyhb)
+              .height(20)
+              .top(function (d) {return 30*d.row;})
+              .left(function(d){return x(d.start_time);})
+              .width(function(d){return x(d.finish_time)-x(d.start_time);})
+              .title(function(d){return "shnums: "+d.response_shnums;})
+              .fillStyle(function(d){return data.server_info[d.serverid].color;})
+              .strokeStyle("black").lineWidth(1);
+
+          vis.add(pv.Rule)
+              .data(data.dyhb)
+              .top(function(d){return 30*d.row + 20/2;})
+              .left(0).width(0)
+              .strokeStyle("#888")
+              .anchor("left").add(pv.Label)
+              .text(function(d){return d.serverid.slice(0,4);});
+
+          /* we use a function for data=relx.ticks() here instead of
+           simply .data(relx.ticks()) so that it will be recalculated when
+           the scales change (by pan/zoom) */
+          var xaxis = vis.add(pv.Rule)
+              .data(function() {return relx.ticks();})
+              .strokeStyle("#ccc")
+              .left(relx)
+              .anchor("bottom").add(pv.Label)
+              .text(function(d){return relx.tickFormat(d)+"s";});
+
+          var read = vis.add(pv.Panel).top(read_top);
+          read.anchor("top").top(-20).add(pv.Label).text("read() requests");
+
+          read.add(pv.Bar)
+              .data(data.read)
+              .height(20)
+              .top(function (d) {return 30*d.row;})
+              .left(function(d){return x(d.start_time);})
+              .width(function(d){return x(d.finish_time)-x(d.start_time);})
+              .title(function(d){return "read(start="+d.start+", len="+d.length+") -> "+d.bytes_returned+" bytes";})
+              .fillStyle("red")
+              .strokeStyle("black").lineWidth(1);
+
+          var segment = vis.add(pv.Panel).top(segment_top);
+          segment.anchor("top").top(-20).add(pv.Label).text("segment() requests");
+
+          segment.add(pv.Bar)
+              .data(data.segment)
+              .height(20)
+              .top(function (d) {return 30*d.row;})
+              .left(function(d){return x(d.start_time);})
+              .width(function(d){return x(d.finish_time)-x(d.start_time);})
+              .title(function(d){return "seg"+d.segment_number+" ["+d.segment_start+":+"+d.segment_length+"] (took "+(d.finish_time-d.start_time)+")";})
+              .fillStyle(function(d){if (d.success) return "#c0ffc0";
+                                    else return "#ffc0c0";})
+              .strokeStyle("black").lineWidth(1);
+
+          var block = vis.add(pv.Panel).top(block_top);
+          block.anchor("top").top(-20).add(pv.Label).text("block() requests");
+
+          var shnum_colors = pv.Colors.category10();
+          block.add(pv.Bar)
+              .data(data.block)
+              .height(10)
+              .top(function (d) {return block_row_to_y[d.row[0]+"-"+d.row[1]];})
+              .left(function(d){return x(d.start_time);})
+              .width(function(d){return x(d.finish_time)-x(d.start_time);})
+              .title(function(d){return "sh"+d.shnum+"-on-"+d.serverid.slice(0,4)+" ["+d.start+":+"+d.length+"] -> "+d.response_length;})
+              .fillStyle(function(d){return data.server_info[d.serverid].color;})
+              .strokeStyle(function(d){return shnum_colors(d.shnum).color;})
+              .lineWidth(function(d)
+                         {if (d.response_length > 100) return 3;
+                         else return 1;
+                          })
+          ;
+
+
+          vis.height(height);
+
+          function transform() {
+              var t0= this.transform();
+              var t = this.transform().invert();
+              // when t.x=0 and t.k=1.0, left should be bounds.min
+              x.domain(bounds.min + (t.x/WIDTH)*duration,
+                       bounds.min + t.k*duration + (t.x/WIDTH)*duration);
+              relx.domain(0 + t.x/WIDTH*duration,
+                          t.k*duration + (t.x/WIDTH)*duration);
+              vis.render();
+          }
+
+          vis.render();
+      }
+
+      $.ajax({url: "event_json",
+              method: 'GET',
+              dataType: 'json',
+              success: onDataReceived });
+});
+
diff --git a/src/allmydata/web/root.py b/src/allmydata/web/root.py
index 3af15d9..fe15a8f 100644
--- a/src/allmydata/web/root.py
+++ b/src/allmydata/web/root.py
@@ -164,6 +164,11 @@ class Root(rend.Page):
         self.child_named = FileHandler(client)
         self.child_status = status.Status(client.get_history())
         self.child_statistics = status.Statistics(client.stats_provider)
+        def f(name):
+            return nevow_File(resource_filename('allmydata.web', name))
+        self.putChild("jquery.js", f("jquery.js"))
+        self.putChild("download_status_timeline.js", f("download_status_timeline.js"))
+        self.putChild("protovis-r3.2.js", f("protovis-r3.2.js"))
 
     def child_helper_status(self, ctx):
         # the Helper isn't attached until after the Tub starts, so this child
diff --git a/src/allmydata/web/status.py b/src/allmydata/web/status.py
index 9f96f1d..5d28bbe 100644
--- a/src/allmydata/web/status.py
+++ b/src/allmydata/web/status.py
@@ -331,6 +331,18 @@ class DownloadResultsRendererMixin(RateAndTimeMixin):
         d.addCallback(_render)
         return d
 
+def tfmt(when):
+    #return when * 1000.0 # stupid JS timestamps
+    return "%.6f" % when
+    # the timeline markers represent UTC. To make these events line up, we
+    # must supply the "Z" suffix.
+    #return "%.2f" % (1000*when)
+    t = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(when))
+    fract = "%.6f" % (when % 1.0)
+    if fract.startswith("0."):
+        fract = fract[2:]
+    return t+"."+fract+"Z"
+
 class DownloadStatusPage(DownloadResultsRendererMixin, rend.Page):
     docFactory = getxmlfile("download-status.xhtml")
 
@@ -338,14 +350,17 @@ class DownloadStatusPage(DownloadResultsRendererMixin, rend.Page):
         rend.Page.__init__(self, data)
         self.download_status = data
 
+    def child_timeline(self, ctx):
+        return DownloadStatusTimelinePage(self.download_status)
+
     def download_results(self):
         return defer.maybeDeferred(self.download_status.get_results)
 
     def relative_time(self, t):
         if t is None:
             return t
-        if self.download_status.started is not None:
-            return t - self.download_status.started
+        if self.download_status.first_timestamp is not None:
+            return t - self.download_status.first_timestamp
         return t
     def short_relative_time(self, t):
         t = self.relative_time(t)
@@ -353,32 +368,145 @@ class DownloadStatusPage(DownloadResultsRendererMixin, rend.Page):
             return ""
         return "+%.6fs" % t
 
-    def renderHTTP(self, ctx):
-        req = inevow.IRequest(ctx)
-        t = get_arg(req, "t")
-        if t == "json":
-            return self.json(req)
-        return rend.Page.renderHTTP(self, ctx)
-
-    def json(self, req):
-        req.setHeader("content-type", "text/plain")
-        data = {}
-        dyhb_events = []
-        for serverid,requests in self.download_status.dyhb_requests.iteritems():
-            for req in requests:
-                dyhb_events.append( (base32.b2a(serverid),) + req )
-        dyhb_events.sort(key=lambda req: req[1])
-        data["dyhb"] = dyhb_events
-        request_events = []
-        for serverid,requests in self.download_status.requests.iteritems():
-            for req in requests:
-                request_events.append( (base32.b2a(serverid),) + req )
-        request_events.sort(key=lambda req: (req[4],req[1]))
-        data["requests"] = request_events
-        data["segment"] = self.download_status.segment_events
-        data["read"] = self.download_status.read_events
+    def _find_overlap(self, events, start_key, end_key):
+        # given a list of event dicts, return a new list in which each event
+        # has an extra "row" key (an int, starting at 0). This is a hint to
+        # our JS frontend about how to overlap the parts of the graph it is
+        # drawing.
+
+        # we must always make a copy, since we're going to be adding "row"
+        # keys and don't want to change the original objects. If we're
+        # stringifying serverids, we'll also be changing the serverid keys.
+        new_events = []
+        rows = []
+        for ev in events:
+            ev = ev.copy()
+            if "serverid" in ev:
+                ev["serverid"] = base32.b2a(ev["serverid"])
+            # find an empty slot in the rows
+            free_slot = None
+            for row,finished in enumerate(rows):
+                if finished is not None:
+                    if ev[start_key] > finished:
+                        free_slot = row
+                        break
+            if free_slot is None:
+                free_slot = len(rows)
+                rows.append(ev[end_key])
+            else:
+                rows[free_slot] = ev[end_key]
+            ev["row"] = free_slot
+            new_events.append(ev)
+        return new_events
+
+    def _find_overlap_requests(self, events):
+        """We compute a three-element 'row tuple' for each event: (serverid,
+        shnum, row). All elements are ints. The first is a mapping from
+        serverid to group number, the second is a mapping from shnum to
+        subgroup number. The third is a row within the subgroup.
+
+        We also return a list of lists of rowcounts, so renderers can decide
+        how much vertical space to give to each row.
+        """
+
+        serverid_to_group = {}
+        groupnum_to_rows = {} # maps groupnum to a table of rows. Each table
+                              # is a list with an element for each row number
+                              # (int starting from 0) that contains a
+                              # finish_time, indicating that the row is empty
+                              # beyond that time. If finish_time is None, it
+                              # indicate a response that has not yet
+                              # completed, so the row cannot be reused.
+        new_events = []
+        for ev in events:
+            # DownloadStatus promises to give us events in temporal order
+            ev = ev.copy()
+            ev["serverid"] = base32.b2a(ev["serverid"])
+            if ev["serverid"] not in serverid_to_group:
+                groupnum = len(serverid_to_group)
+                serverid_to_group[ev["serverid"]] = groupnum
+            groupnum = serverid_to_group[ev["serverid"]]
+            if groupnum not in groupnum_to_rows:
+                groupnum_to_rows[groupnum] = []
+            rows = groupnum_to_rows[groupnum]
+            # find an empty slot in the rows
+            free_slot = None
+            for row,finished in enumerate(rows):
+                if finished is not None:
+                    if ev["start_time"] > finished:
+                        free_slot = row
+                        break
+            if free_slot is None:
+                free_slot = len(rows)
+                rows.append(ev["finish_time"])
+            else:
+                rows[free_slot] = ev["finish_time"]
+            ev["row"] = (groupnum, free_slot)
+            new_events.append(ev)
+        # maybe also return serverid_to_group, groupnum_to_rows, and some
+        # indication of the highest finish_time
+        #
+        # actually, return the highest rownum for each groupnum
+        highest_rownums = [len(groupnum_to_rows[groupnum])
+                           for groupnum in range(len(serverid_to_group))]
+        return new_events, highest_rownums
+
+    def child_timeline_parameters(self, ctx):
+        ds = self.download_status
+        d = { "start": tfmt(ds.started),
+              "end": tfmt(ds.started+2.0),
+              }
+        return simplejson.dumps(d, indent=1) + "\n"
+
+    def child_event_json(self, ctx):
+        inevow.IRequest(ctx).setHeader("content-type", "text/plain")
+        data = { } # this will be returned to the GET
+        ds = self.download_status
+
+        data["read"] = self._find_overlap(ds.read_events,
+                                          "start_time", "finish_time")
+        data["segment"] = self._find_overlap(ds.segment_events,
+                                             "start_time", "finish_time")
+        data["dyhb"] = self._find_overlap(ds.dyhb_requests,
+                                          "start_time", "finish_time")
+        data["block"],data["block_rownums"] = self._find_overlap_requests(ds.block_requests)
+
+        servernums = {}
+        serverid_strings = {}
+        for d_ev in data["dyhb"]:
+            if d_ev["serverid"] not in servernums:
+                servernum = len(servernums)
+                servernums[d_ev["serverid"]] = servernum
+                #title= "%s: %s" % ( ",".join([str(shnum) for shnum in shnums]))
+                serverid_strings[servernum] = d_ev["serverid"][:4]
+        data["server_info"] = dict([(serverid, {"num": servernums[serverid],
+                                                "color": self.color(base32.a2b(serverid)),
+                                                "short": serverid_strings[servernum],
+                                                })
+                                   for serverid in servernums.keys()])
+        data["num_serverids"] = len(serverid_strings)
+        data["serverids"] = serverid_strings;
+        data["bounds"] = {"min": ds.first_timestamp,
+                          "max": ds.last_timestamp,
+                          }
+        # for testing
+        ## data["bounds"]["max"] = tfmt(max([d_ev["finish_time"]
+        ##                                   for d_ev in data["dyhb"]
+        ##                                   if d_ev["finish_time"] is not None]
+        ##                                  ))
         return simplejson.dumps(data, indent=1) + "\n"
 
+    def render_timeline_link(self, ctx, data):
+        from nevow import url
+        return T.a(href=url.URL.fromContext(ctx).child("timeline"))["timeline"]
+
+    def _rate_and_time(self, bytes, seconds):
+        time_s = self.render_time(None, seconds)
+        if seconds != 0:
+            rate = self.render_rate(None, 1.0 * bytes / seconds)
+            return T.span(title=rate)[time_s]
+        return T.span[time_s]
+
     def render_events(self, ctx, data):
         if not self.download_status.storage_index:
             return
@@ -388,13 +516,11 @@ class DownloadStatusPage(DownloadResultsRendererMixin, rend.Page):
         t = T.table(class_="status-download-events")
         t[T.tr[T.td["serverid"], T.td["sent"], T.td["received"],
                T.td["shnums"], T.td["RTT"]]]
-        dyhb_events = []
-        for serverid,requests in self.download_status.dyhb_requests.iteritems():
-            for req in requests:
-                dyhb_events.append( (serverid,) + req )
-        dyhb_events.sort(key=lambda req: req[1])
-        for d_ev in dyhb_events:
-            (serverid, sent, shnums, received) = d_ev
+        for d_ev in self.download_status.dyhb_requests:
+            serverid = d_ev["serverid"]
+            sent = d_ev["start_time"]
+            shnums = d_ev["response_shnums"]
+            received = d_ev["finish_time"]
             serverid_s = idlib.shortnodeid_b2a(serverid)
             rtt = None
             if received is not None:
@@ -413,67 +539,74 @@ class DownloadStatusPage(DownloadResultsRendererMixin, rend.Page):
                T.td["time"], T.td["decrypttime"], T.td["pausedtime"],
                T.td["speed"]]]
         for r_ev in self.download_status.read_events:
-            (start, length, requesttime, finishtime, bytes, decrypt, paused) = r_ev
-            if finishtime is not None:
-                rtt = finishtime - requesttime - paused
+            start = r_ev["start"]
+            length = r_ev["length"]
+            bytes = r_ev["bytes_returned"]
+            decrypt_time = ""
+            if bytes:
+                decrypt_time = self._rate_and_time(bytes, r_ev["decrypt_time"])
+            speed, rtt = "",""
+            if r_ev["finish_time"] is not None:
+                rtt = r_ev["finish_time"] - r_ev["start_time"] - r_ev["paused_time"]
                 speed = self.render_rate(None, compute_rate(bytes, rtt))
                 rtt = self.render_time(None, rtt)
-                decrypt = self.render_time(None, decrypt)
-                paused = self.render_time(None, paused)
-            else:
-                speed, rtt, decrypt, paused = "","","",""
+            paused = self.render_time(None, r_ev["paused_time"])
+
             t[T.tr[T.td["[%d:+%d]" % (start, length)],
-                   T.td[srt(requesttime)], T.td[srt(finishtime)],
-                   T.td[bytes], T.td[rtt], T.td[decrypt], T.td[paused],
+                   T.td[srt(r_ev["start_time"])], T.td[srt(r_ev["finish_time"])],
+                   T.td[bytes], T.td[rtt],
+                   T.td[decrypt_time], T.td[paused],
                    T.td[speed],
                    ]]
         l["Read Events:", t]
 
         t = T.table(class_="status-download-events")
-        t[T.tr[T.td["type"], T.td["segnum"], T.td["when"], T.td["range"],
+        t[T.tr[T.td["segnum"], T.td["start"], T.td["active"], T.td["finish"],
+               T.td["range"],
                T.td["decodetime"], T.td["segtime"], T.td["speed"]]]
-        reqtime = (None, None)
         for s_ev in self.download_status.segment_events:
-            (etype, segnum, when, segstart, seglen, decodetime) = s_ev
-            if etype == "request":
-                t[T.tr[T.td["request"], T.td["seg%d" % segnum],
-                       T.td[srt(when)]]]
-                reqtime = (segnum, when)
-            elif etype == "delivery":
-                if reqtime[0] == segnum:
-                    segtime = when - reqtime[1]
+            range_s = ""
+            segtime_s = ""
+            speed = ""
+            decode_time = ""
+            if s_ev["finish_time"] is not None:
+                if s_ev["success"]:
+                    segtime = s_ev["finish_time"] - s_ev["active_time"]
+                    segtime_s = self.render_time(None, segtime)
+                    seglen = s_ev["segment_length"]
+                    range_s = "[%d:+%d]" % (s_ev["segment_start"], seglen)
                     speed = self.render_rate(None, compute_rate(seglen, segtime))
-                    segtime = self.render_time(None, segtime)
+                    decode_time = self._rate_and_time(seglen, s_ev["decode_time"])
                 else:
-                    segtime, speed = "", ""
-                t[T.tr[T.td["delivery"], T.td["seg%d" % segnum],
-                       T.td[srt(when)],
-                       T.td["[%d:+%d]" % (segstart, seglen)],
-                       T.td[self.render_time(None,decodetime)],
-                       T.td[segtime], T.td[speed]]]
-            elif etype == "error":
-                t[T.tr[T.td["error"], T.td["seg%d" % segnum]]]
+                    # error
+                    range_s = "error"
+            else:
+                # not finished yet
+                pass
+
+            t[T.tr[T.td["seg%d" % s_ev["segment_number"]],
+                   T.td[srt(s_ev["start_time"])],
+                   T.td[srt(s_ev["active_time"])],
+                   T.td[srt(s_ev["finish_time"])],
+                   T.td[range_s],
+                   T.td[decode_time],
+                   T.td[segtime_s], T.td[speed]]]
         l["Segment Events:", t]
 
         t = T.table(border="1")
         t[T.tr[T.td["serverid"], T.td["shnum"], T.td["range"],
-               T.td["txtime"], T.td["rxtime"], T.td["received"], T.td["RTT"]]]
-        reqtime = (None, None)
-        request_events = []
-        for serverid,requests in self.download_status.requests.iteritems():
-            for req in requests:
-                request_events.append( (serverid,) + req )
-        request_events.sort(key=lambda req: (req[4],req[1]))
-        for r_ev in request_events:
-            (peerid, shnum, start, length, sent, receivedlen, received) = r_ev
+               T.td["txtime"], T.td["rxtime"],
+               T.td["received"], T.td["RTT"]]]
+        for r_ev in self.download_status.block_requests:
             rtt = None
-            if received is not None:
-                rtt = received - sent
-            peerid_s = idlib.shortnodeid_b2a(peerid)
-            t[T.tr(style="background: %s" % self.color(peerid))[
-                T.td[peerid_s], T.td[shnum],
-                T.td["[%d:+%d]" % (start, length)],
-                T.td[srt(sent)], T.td[srt(received)], T.td[receivedlen],
+            if r_ev["finish_time"] is not None:
+                rtt = r_ev["finish_time"] - r_ev["start_time"]
+            serverid_s = idlib.shortnodeid_b2a(r_ev["serverid"])
+            t[T.tr(style="background: %s" % self.color(r_ev["serverid"]))[
+                T.td[serverid_s], T.td[r_ev["shnum"]],
+                T.td["[%d:+%d]" % (r_ev["start"], r_ev["length"])],
+                T.td[srt(r_ev["start_time"])], T.td[srt(r_ev["finish_time"])],
+                T.td[r_ev["response_length"] or ""],
                 T.td[self.render_time(None, rtt)],
                 ]]
         l["Requests:", t]
@@ -524,6 +657,39 @@ class DownloadStatusPage(DownloadResultsRendererMixin, rend.Page):
     def render_status(self, ctx, data):
         return data.get_status()
 
+class DownloadStatusTimelinePage(rend.Page):
+    docFactory = getxmlfile("download-status-timeline.xhtml")
+
+    def render_started(self, ctx, data):
+        TIME_FORMAT = "%H:%M:%S %d-%b-%Y"
+        started_s = time.strftime(TIME_FORMAT,
+                                  time.localtime(data.get_started()))
+        return started_s + " (%s)" % data.get_started()
+
+    def render_si(self, ctx, data):
+        si_s = base32.b2a_or_none(data.get_storage_index())
+        if si_s is None:
+            si_s = "(None)"
+        return si_s
+
+    def render_helper(self, ctx, data):
+        return {True: "Yes",
+                False: "No"}[data.using_helper()]
+
+    def render_total_size(self, ctx, data):
+        size = data.get_size()
+        if size is None:
+            return "(unknown)"
+        return size
+
+    def render_progress(self, ctx, data):
+        progress = data.get_progress()
+        # TODO: make an ascii-art bar
+        return "%.1f%%" % (100.0 * progress)
+
+    def render_status(self, ctx, data):
+        return data.get_status()
+
 class RetrieveStatusPage(rend.Page, RateAndTimeMixin):
     docFactory = getxmlfile("retrieve-status.xhtml")
 
